
#ifndef _MU_H_
#define _MU_H_

#ifdef WIN32
#ifndef LIBMUTILS
#define mutils_export extern __declspec(dllimport)
#else
#define mutils_export extern __declspec(dllexport)
#endif
#else
#define mutils_export extern
#endif

#define SLASH_2_DIR_SEP(s) {char *t; for(t=strchr(s, '/'    ); t; t=strchr(t+1, '/'    )) *t=DIR_SEP;}
#define DIR_SEP_2_SLASH(s) {char *t; for(t=strchr(s, DIR_SEP); t; t=strchr(t+1, DIR_SEP)) *t='/'    ;}


#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif

#include <stdio.h>		/* NULL, printf etc. */
#include <stdlib.h>
#include <errno.h>
#include <stdarg.h>		/* va_alist.. */

/* AIX requires this to be the first thing in the file.  */
#ifdef HAVE_ALLOCA_H
#  include <alloca.h>
#else
#  ifdef _AIX
#pragma alloca
#  else
#   ifndef alloca		/* predefined by HP cc +Olibcalls */
void *alloca(size_t);
#   endif
#  endif
#endif

#include <assert.h>

/* Backward compatibility: configure figures out whether it needs to
   define "inline" as something else for the architecture it is testing.
   All uses in the source use "INLINE", so until all occurances of
   "INLINE" have been replaced by "inline", we just define the latter as
   the former. */
#define INLINE	inline

#define REGISTER	register

#ifdef HAVE_LONG_LONG
typedef long long lng;

#define SIZEOF_LNG SIZEOF_LONG_LONG
#else
#ifdef HAVE___INT64
typedef __int64 lng;

#define SIZEOF_LNG SIZEOF___INT64
#endif
#endif

#ifndef HAVE_SSIZE_T
#if SIZEOF_SIZE_T == SIZEOF_INT
typedef int ssize_t;
#else
typedef lng ssize_t;
#endif
#define HAVE_SSIZE_T 1
#endif

#ifndef HAVE_PTRDIFF_T
#if SIZEOF_SIZE_T == SIZEOF_INT
typedef int ptrdiff_t;
#else
typedef lng ptrdiff_t;
#endif
#define HAVE_PTRDIFF_T 1
#endif

/* define printf formats for printing size_t and ssize_t variables */
#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901 && !defined(__svr4__) && !defined(WIN32) && !defined(__sgi) && (!defined(__APPLE_CC__) || __GNUC__ > 3)
#define SZFMT "%zu"
#define SSZFMT "%zd"
#elif defined(__MINGW32__)
#define SZFMT "%u"
#define SSZFMT "%ld"
#elif defined(__APPLE_CC__) /* && __GNUC__ <= 3 */
#define SZFMT "%zu"
	#if SIZEOF_SIZE_T == SIZEOF_INT
	#define SSZFMT "%d"
	#else
	#define SSZFMT "%ld"
	#endif
#elif SIZEOF_SIZE_T == SIZEOF_INT
#define SZFMT "%u"
#define SSZFMT "%d"
#elif SIZEOF_SIZE_T == SIZEOF_LONG
#define SZFMT "%lu"
#define SSZFMT "%ld"
#elif SIZEOF_SIZE_T == SIZEOF_LONG_LONG || SIZEOF_SIZE_T == SIZEOF___INT64
#define SZFMT ULLFMT
#define SSZFMT LLFMT
#else
#error no definition for SZFMT/SSZFMT
#endif

/* prompts for MAPI protocol */
#define PROMPTBEG	'\001'	/* start prompt bracket */
#define PROMPT1		"\001\001\n"	/* prompt: ready for new query */
#define PROMPT2		"\001\002\n"	/* prompt: more data needed */

#endif /* _MU_H_ */

