
#ifndef _GDK_SCANSELECT_H
#define _GDK_SCANSELECT_H
#include "gdk.h"



#ifdef NOEXPAND_CHR
#ifndef NOEXPAND_BIT
#define NOEXPAND_BIT 1
#endif
#ifndef NOEXPAND_BTE
#define NOEXPAND_BTE 1
#endif
#endif

#ifdef NOEXPAND_INT
#ifndef NOEXPAND_FLT
#define NOEXPAND_FLT 1
#endif
#ifndef NOEXPAND_BAT
#define NOEXPAND_BAT 1
#endif
#if SIZEOF_OID == SIZEOF_INT && !defined(NOEXPAND_OID)
#define NOEXPAND_OID 1
#endif
#if SIZEOF_WRD == SIZEOF_INT && !defined(NOEXPAND_WRD)
#define NOEXPAND_WRD 1
#endif
#if SIZEOF_PTR == SIZEOF_INT && !defined(NOEXPAND_PTR)
#define NOEXPAND_PTR 1
#endif
#endif

#ifdef NOEXPAND_LNG
#ifndef NOEXPAND_DBL
#define NOEXPAND_DBL 1
#endif
#if SIZEOF_OID == SIZEOF_LNG && !defined(NOEXPAND_OID)
#define NOEXPAND_OID 1
#endif
#if SIZEOF_WRD == SIZEOF_LNG && !defined(NOEXPAND_WRD)
#define NOEXPAND_WRD 1
#endif
#if SIZEOF_PTR == SIZEOF_LNG && !defined(NOEXPAND_PTR)
#define NOEXPAND_PTR 1
#endif
#endif

#if defined(NOEXPAND_CHR) || defined(SKIP_TYPE_EXPANSIONS)
#define ATOM_PUT_CHR(tpe,hp,dst,p,src)		\
	if (tpe == TYPE_chr) {			\
		((chr*) dst)[p] = *(chr*) src;	\
	} else
#else
#define ATOM_PUT_CHR(tpe,hp,dst,p,src)
#endif
#if defined(NOEXPAND_BTE) || defined(SKIP_TYPE_EXPANSIONS)
#define ATOM_PUT_BTE(tpe,hp,dst,p,src)		\
	if (tpe == TYPE_bte) {			\
		*(bte*) dst = *(bte*) src;	\
	} else
#else
#define ATOM_PUT_BTE(tpe,hp,dst,p,src)
#endif
#if defined(NOEXPAND_SHT) || defined(SKIP_TYPE_EXPANSIONS)
#define ATOM_PUT_SHT(tpe,hp,dst,p,src)		\
	if (tpe == TYPE_sht) {			\
		((sht*) dst)[p] = *(sht*) src;	\
	} else
#else
#define ATOM_PUT_SHT(tpe,hp,dst,p,src)
#endif
#if defined(NOEXPAND_INT) || defined(SKIP_TYPE_EXPANSIONS)
#define ATOM_PUT_INT(tpe,hp,dst,p,src)		\
	if (tpe == TYPE_int) {			\
		((int*) dst)[p] = *(int*) src;	\
	} else
#else
#define ATOM_PUT_INT(tpe,hp,dst,p,src)
#endif
#if defined(NOEXPAND_LNG) || defined(SKIP_TYPE_EXPANSIONS)
#define ATOM_PUT_LNG(tpe,hp,dst,p,src)		\
	if (tpe == TYPE_lng) {			\
		((lng*) dst)[p] = *(lng*) src;	\
	} else
#else
#define ATOM_PUT_LNG(tpe,hp,dst,p,src)
#endif

#define FIXEDATOM_PUT(sh,tpe,hp,dst,p,src)				\
	ATOM_PUT_CHR(tpe,hp,dst,p,src)					\
	ATOM_PUT_SHT(tpe,hp,dst,p,src)					\
	ATOM_PUT_INT(tpe,hp,dst,p,src)					\
	ATOM_PUT_LNG(tpe,hp,dst,p,src)					\
	if (tpe == TYPE_bat) {						\
		BBPincref(*(bat*) src, TRUE);				\
		((bat*) dst)[p] = *(bat*) src;				\
	} else {							\
		memcpy(dst+(p<<sh), src, (size_t) ATOMsize(tpe));	\
	}								

#define VARATOM_PUT(sh,tpe,hp,dst,p,src)					\
	if (tpe == TYPE_str) {						\
		if (strPut(hp, ((var_t*) dst)+(p), (str) (src)) == 0) {	\
				goto bunins_failed;			\
		}							\
	}



#define SIMPLE_PUT(sh,tpe,hp,dst,p,src) ((tpe*)(dst))[p] = *(tpe*)(ptr)(src); 
#define VOID_PUT(sh,tpe,hp,dst,p,src)   {}
#define VID_PUT(sh,tpe,hp,dst,p,src) ((oid*)(dst))[p] = src; 






	
#define voidvoid_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VOID_PUT(b->H->shift, void, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VOID_PUT(b->T->shift, void, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define voidvoid_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		voidvoid_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define voidvoid_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		voidvoid_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define voidchr_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VOID_PUT(b->H->shift, void, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, chr, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define voidchr_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		voidchr_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define voidchr_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		voidchr_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define voidbte_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VOID_PUT(b->H->shift, void, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, bte, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define voidbte_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		voidbte_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define voidbte_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		voidbte_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define voidsht_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VOID_PUT(b->H->shift, void, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, sht, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define voidsht_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		voidsht_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define voidsht_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		voidsht_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define voidint_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VOID_PUT(b->H->shift, void, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, int, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define voidint_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		voidint_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define voidint_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		voidint_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define voidlng_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VOID_PUT(b->H->shift, void, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, lng, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define voidlng_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		voidlng_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define voidlng_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		voidlng_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define voidfix_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VOID_PUT(b->H->shift, void, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		FIXEDATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define voidfix_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		voidfix_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define voidfix_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		voidfix_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define voidvar_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VOID_PUT(b->H->shift, void, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VARATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define voidvar_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		voidvar_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define voidvar_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		voidvar_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)








	
#define chrvoid_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, chr, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VOID_PUT(b->T->shift, void, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define chrvoid_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		chrvoid_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define chrvoid_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		chrvoid_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define chrchr_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, chr, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, chr, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define chrchr_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		chrchr_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define chrchr_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		chrchr_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define chrbte_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, chr, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, bte, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define chrbte_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		chrbte_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define chrbte_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		chrbte_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define chrsht_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, chr, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, sht, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define chrsht_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		chrsht_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define chrsht_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		chrsht_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define chrint_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, chr, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, int, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define chrint_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		chrint_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define chrint_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		chrint_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define chrlng_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, chr, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, lng, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define chrlng_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		chrlng_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define chrlng_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		chrlng_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define chrfix_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, chr, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		FIXEDATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define chrfix_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		chrfix_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define chrfix_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		chrfix_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define chrvar_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, chr, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VARATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define chrvar_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		chrvar_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define chrvar_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		chrvar_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)








	
#define btevoid_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, bte, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VOID_PUT(b->T->shift, void, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define btevoid_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		btevoid_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define btevoid_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		btevoid_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define btechr_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, bte, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, chr, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define btechr_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		btechr_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define btechr_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		btechr_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define btebte_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, bte, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, bte, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define btebte_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		btebte_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define btebte_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		btebte_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define btesht_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, bte, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, sht, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define btesht_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		btesht_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define btesht_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		btesht_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define bteint_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, bte, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, int, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define bteint_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		bteint_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define bteint_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		bteint_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define btelng_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, bte, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, lng, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define btelng_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		btelng_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define btelng_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		btelng_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define btefix_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, bte, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		FIXEDATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define btefix_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		btefix_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define btefix_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		btefix_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define btevar_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, bte, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VARATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define btevar_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		btevar_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define btevar_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		btevar_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)








	
#define shtvoid_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, sht, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VOID_PUT(b->T->shift, void, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define shtvoid_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		shtvoid_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define shtvoid_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		shtvoid_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define shtchr_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, sht, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, chr, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define shtchr_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		shtchr_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define shtchr_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		shtchr_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define shtbte_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, sht, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, bte, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define shtbte_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		shtbte_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define shtbte_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		shtbte_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define shtsht_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, sht, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, sht, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define shtsht_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		shtsht_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define shtsht_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		shtsht_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define shtint_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, sht, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, int, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define shtint_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		shtint_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define shtint_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		shtint_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define shtlng_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, sht, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, lng, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define shtlng_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		shtlng_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define shtlng_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		shtlng_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define shtfix_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, sht, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		FIXEDATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define shtfix_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		shtfix_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define shtfix_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		shtfix_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define shtvar_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, sht, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VARATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define shtvar_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		shtvar_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define shtvar_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		shtvar_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)








	
#define intvoid_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, int, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VOID_PUT(b->T->shift, void, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define intvoid_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		intvoid_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define intvoid_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		intvoid_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define intchr_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, int, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, chr, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define intchr_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		intchr_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define intchr_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		intchr_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define intbte_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, int, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, bte, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define intbte_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		intbte_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define intbte_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		intbte_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define intsht_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, int, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, sht, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define intsht_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		intsht_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define intsht_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		intsht_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define intint_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, int, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, int, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define intint_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		intint_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define intint_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		intint_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define intlng_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, int, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, lng, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define intlng_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		intlng_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define intlng_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		intlng_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define intfix_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, int, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		FIXEDATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define intfix_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		intfix_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define intfix_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		intfix_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define intvar_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, int, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VARATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define intvar_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		intvar_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define intvar_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		intvar_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)








	
#define lngvoid_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, lng, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VOID_PUT(b->T->shift, void, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define lngvoid_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		lngvoid_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define lngvoid_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		lngvoid_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define lngchr_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, lng, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, chr, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define lngchr_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		lngchr_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define lngchr_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		lngchr_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define lngbte_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, lng, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, bte, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define lngbte_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		lngbte_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define lngbte_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		lngbte_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define lngsht_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, lng, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, sht, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define lngsht_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		lngsht_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define lngsht_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		lngsht_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define lngint_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, lng, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, int, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define lngint_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		lngint_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define lngint_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		lngint_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define lnglng_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, lng, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, lng, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define lnglng_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		lnglng_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define lnglng_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		lnglng_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define lngfix_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, lng, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		FIXEDATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define lngfix_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		lngfix_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define lngfix_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		lngfix_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define lngvar_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		SIMPLE_PUT(b->H->shift, lng, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VARATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define lngvar_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		lngvar_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define lngvar_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		lngvar_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)








	
#define vidvoid_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VID_PUT(b->H->shift, vid, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VOID_PUT(b->T->shift, void, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define vidvoid_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		vidvoid_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define vidvoid_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		vidvoid_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define vidchr_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VID_PUT(b->H->shift, vid, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, chr, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define vidchr_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		vidchr_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define vidchr_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		vidchr_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define vidbte_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VID_PUT(b->H->shift, vid, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, bte, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define vidbte_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		vidbte_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define vidbte_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		vidbte_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define vidsht_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VID_PUT(b->H->shift, vid, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, sht, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define vidsht_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		vidsht_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define vidsht_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		vidsht_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define vidint_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VID_PUT(b->H->shift, vid, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, int, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define vidint_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		vidint_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define vidint_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		vidint_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define vidlng_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VID_PUT(b->H->shift, vid, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, lng, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define vidlng_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		vidlng_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define vidlng_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		vidlng_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define vidfix_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VID_PUT(b->H->shift, vid, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		FIXEDATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define vidfix_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		vidfix_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define vidfix_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		vidfix_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define vidvar_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VID_PUT(b->H->shift, vid, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VARATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define vidvar_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		vidvar_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define vidvar_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		vidvar_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)








	
#define fixvoid_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		FIXEDATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VOID_PUT(b->T->shift, void, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define fixvoid_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		fixvoid_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define fixvoid_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		fixvoid_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define fixchr_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		FIXEDATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, chr, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define fixchr_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		fixchr_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define fixchr_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		fixchr_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define fixbte_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		FIXEDATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, bte, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define fixbte_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		fixbte_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define fixbte_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		fixbte_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define fixsht_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		FIXEDATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, sht, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define fixsht_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		fixsht_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define fixsht_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		fixsht_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define fixint_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		FIXEDATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, int, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define fixint_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		fixint_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define fixint_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		fixint_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define fixlng_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		FIXEDATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, lng, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define fixlng_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		fixlng_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define fixlng_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		fixlng_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define fixfix_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		FIXEDATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		FIXEDATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define fixfix_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		fixfix_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define fixfix_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		fixfix_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define fixvar_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		FIXEDATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VARATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define fixvar_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		fixvar_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define fixvar_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		fixvar_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)








	
#define varvoid_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VARATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VOID_PUT(b->T->shift, void, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define varvoid_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		varvoid_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define varvoid_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		varvoid_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define varchr_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VARATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, chr, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define varchr_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		varchr_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define varchr_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		varchr_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define varbte_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VARATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, bte, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define varbte_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		varbte_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define varbte_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		varbte_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define varsht_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VARATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, sht, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define varsht_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		varsht_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define varsht_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		varsht_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define varint_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VARATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, int, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define varint_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		varint_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define varint_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		varint_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define varlng_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VARATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		SIMPLE_PUT(b->T->shift, lng, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define varlng_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		varlng_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define varlng_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		varlng_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define varfix_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VARATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		FIXEDATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define varfix_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		varfix_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define varfix_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		varfix_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)




	
#define varvar_bunfastins_nocheck_noinc(b, p, h, t)		\
	do {							\
		VARATOM_PUT(b->H->shift, (b)->htype, (b)->H->vheap, (b)->H->heap.base, p, h);	\
		VARATOM_PUT(b->T->shift, (b)->ttype, (b)->T->vheap, (b)->T->heap.base, p, t);	\
	} while (0)
#define varvar_bunfastins_nocheck(b, p, h, t, hs, ts)		\
	do {							\
		(b)->H->heap.free += hs;			\
		(b)->T->heap.free += ts;			\
		(b)->batCount ++;				\
		varvar_bunfastins_nocheck_noinc(b, p, h, t);	\
	} while (0)
#define varvar_bunfastins(b, h, t)					\
	do {								\
		REGISTER BUN _p = BUNlast(b);				\
		REGISTER size_t _hsize = Hsize(b);			\
		REGISTER size_t _tsize = Tsize(b);			\
		if (BATcount(b) + 1 > BATcapacity(b)){			\
			if (BATextend(b, BATgrows(b)) == NULL)  	\
				goto bunins_failed; 			\
		}							\
		varvar_bunfastins_nocheck(b, _p, h, t, _hsize, _tsize);	\
	} while (0)











#define voidflt_bunfastins_nocheck_noinc(b, p, h, t) voidint_bunfastins_nocheck_noinc(b, p, h, t)
#define voidflt_bunfastins_nocheck(b, p, h, t, hs, ts)    voidint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define voidflt_bunfastins(b, h, t)                  voidint_bunfastins(b, h, t)
#define fltvoid_bunfastins_nocheck_noinc(b, p, h, t) intvoid_bunfastins_nocheck_noinc(b, p, h, t)
#define fltvoid_bunfastins_nocheck(b, p, h, t, hs, ts)    intvoid_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fltvoid_bunfastins(b, h, t)                  intvoid_bunfastins(b, h, t)




#define chrflt_bunfastins_nocheck_noinc(b, p, h, t) chrint_bunfastins_nocheck_noinc(b, p, h, t)
#define chrflt_bunfastins_nocheck(b, p, h, t, hs, ts)    chrint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define chrflt_bunfastins(b, h, t)                  chrint_bunfastins(b, h, t)
#define fltchr_bunfastins_nocheck_noinc(b, p, h, t) intchr_bunfastins_nocheck_noinc(b, p, h, t)
#define fltchr_bunfastins_nocheck(b, p, h, t, hs, ts)    intchr_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fltchr_bunfastins(b, h, t)                  intchr_bunfastins(b, h, t)




#define shtflt_bunfastins_nocheck_noinc(b, p, h, t) shtint_bunfastins_nocheck_noinc(b, p, h, t)
#define shtflt_bunfastins_nocheck(b, p, h, t, hs, ts)    shtint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define shtflt_bunfastins(b, h, t)                  shtint_bunfastins(b, h, t)
#define fltsht_bunfastins_nocheck_noinc(b, p, h, t) intsht_bunfastins_nocheck_noinc(b, p, h, t)
#define fltsht_bunfastins_nocheck(b, p, h, t, hs, ts)    intsht_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fltsht_bunfastins(b, h, t)                  intsht_bunfastins(b, h, t)




#define intflt_bunfastins_nocheck_noinc(b, p, h, t) intint_bunfastins_nocheck_noinc(b, p, h, t)
#define intflt_bunfastins_nocheck(b, p, h, t, hs, ts)    intint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define intflt_bunfastins(b, h, t)                  intint_bunfastins(b, h, t)
#define fltint_bunfastins_nocheck_noinc(b, p, h, t) intint_bunfastins_nocheck_noinc(b, p, h, t)
#define fltint_bunfastins_nocheck(b, p, h, t, hs, ts)    intint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fltint_bunfastins(b, h, t)                  intint_bunfastins(b, h, t)




#define lngflt_bunfastins_nocheck_noinc(b, p, h, t) lngint_bunfastins_nocheck_noinc(b, p, h, t)
#define lngflt_bunfastins_nocheck(b, p, h, t, hs, ts)    lngint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define lngflt_bunfastins(b, h, t)                  lngint_bunfastins(b, h, t)
#define fltlng_bunfastins_nocheck_noinc(b, p, h, t) intlng_bunfastins_nocheck_noinc(b, p, h, t)
#define fltlng_bunfastins_nocheck(b, p, h, t, hs, ts)    intlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fltlng_bunfastins(b, h, t)                  intlng_bunfastins(b, h, t)




#define fixflt_bunfastins_nocheck_noinc(b, p, h, t) fixint_bunfastins_nocheck_noinc(b, p, h, t)
#define fixflt_bunfastins_nocheck(b, p, h, t, hs, ts)    fixint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fixflt_bunfastins(b, h, t)                  fixint_bunfastins(b, h, t)
#define fltfix_bunfastins_nocheck_noinc(b, p, h, t) intfix_bunfastins_nocheck_noinc(b, p, h, t)
#define fltfix_bunfastins_nocheck(b, p, h, t, hs, ts)    intfix_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fltfix_bunfastins(b, h, t)                  intfix_bunfastins(b, h, t)




#define varflt_bunfastins_nocheck_noinc(b, p, h, t) varint_bunfastins_nocheck_noinc(b, p, h, t)
#define varflt_bunfastins_nocheck(b, p, h, t, hs, ts)    varint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define varflt_bunfastins(b, h, t)                  varint_bunfastins(b, h, t)
#define fltvar_bunfastins_nocheck_noinc(b, p, h, t) intvar_bunfastins_nocheck_noinc(b, p, h, t)
#define fltvar_bunfastins_nocheck(b, p, h, t, hs, ts)    intvar_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fltvar_bunfastins(b, h, t)                  intvar_bunfastins(b, h, t)




#define voiddbl_bunfastins_nocheck_noinc(b, p, h, t) voidlng_bunfastins_nocheck_noinc(b, p, h, t)
#define voiddbl_bunfastins_nocheck(b, p, h, t, hs, ts)    voidlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define voiddbl_bunfastins(b, h, t)                  voidlng_bunfastins(b, h, t)
#define dblvoid_bunfastins_nocheck_noinc(b, p, h, t) lngvoid_bunfastins_nocheck_noinc(b, p, h, t)
#define dblvoid_bunfastins_nocheck(b, p, h, t, hs, ts)    lngvoid_bunfastins_nocheck(b, p, h, t, hs, ts)
#define dblvoid_bunfastins(b, h, t)                  lngvoid_bunfastins(b, h, t)




#define chrdbl_bunfastins_nocheck_noinc(b, p, h, t) chrlng_bunfastins_nocheck_noinc(b, p, h, t)
#define chrdbl_bunfastins_nocheck(b, p, h, t, hs, ts)    chrlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define chrdbl_bunfastins(b, h, t)                  chrlng_bunfastins(b, h, t)
#define dblchr_bunfastins_nocheck_noinc(b, p, h, t) lngchr_bunfastins_nocheck_noinc(b, p, h, t)
#define dblchr_bunfastins_nocheck(b, p, h, t, hs, ts)    lngchr_bunfastins_nocheck(b, p, h, t, hs, ts)
#define dblchr_bunfastins(b, h, t)                  lngchr_bunfastins(b, h, t)




#define shtdbl_bunfastins_nocheck_noinc(b, p, h, t) shtlng_bunfastins_nocheck_noinc(b, p, h, t)
#define shtdbl_bunfastins_nocheck(b, p, h, t, hs, ts)    shtlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define shtdbl_bunfastins(b, h, t)                  shtlng_bunfastins(b, h, t)
#define dblsht_bunfastins_nocheck_noinc(b, p, h, t) lngsht_bunfastins_nocheck_noinc(b, p, h, t)
#define dblsht_bunfastins_nocheck(b, p, h, t, hs, ts)    lngsht_bunfastins_nocheck(b, p, h, t, hs, ts)
#define dblsht_bunfastins(b, h, t)                  lngsht_bunfastins(b, h, t)




#define intdbl_bunfastins_nocheck_noinc(b, p, h, t) intlng_bunfastins_nocheck_noinc(b, p, h, t)
#define intdbl_bunfastins_nocheck(b, p, h, t, hs, ts)    intlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define intdbl_bunfastins(b, h, t)                  intlng_bunfastins(b, h, t)
#define dblint_bunfastins_nocheck_noinc(b, p, h, t) lngint_bunfastins_nocheck_noinc(b, p, h, t)
#define dblint_bunfastins_nocheck(b, p, h, t, hs, ts)    lngint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define dblint_bunfastins(b, h, t)                  lngint_bunfastins(b, h, t)




#define lngdbl_bunfastins_nocheck_noinc(b, p, h, t) lnglng_bunfastins_nocheck_noinc(b, p, h, t)
#define lngdbl_bunfastins_nocheck(b, p, h, t, hs, ts)    lnglng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define lngdbl_bunfastins(b, h, t)                  lnglng_bunfastins(b, h, t)
#define dbllng_bunfastins_nocheck_noinc(b, p, h, t) lnglng_bunfastins_nocheck_noinc(b, p, h, t)
#define dbllng_bunfastins_nocheck(b, p, h, t, hs, ts)    lnglng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define dbllng_bunfastins(b, h, t)                  lnglng_bunfastins(b, h, t)




#define fixdbl_bunfastins_nocheck_noinc(b, p, h, t) fixlng_bunfastins_nocheck_noinc(b, p, h, t)
#define fixdbl_bunfastins_nocheck(b, p, h, t, hs, ts)    fixlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fixdbl_bunfastins(b, h, t)                  fixlng_bunfastins(b, h, t)
#define dblfix_bunfastins_nocheck_noinc(b, p, h, t) lngfix_bunfastins_nocheck_noinc(b, p, h, t)
#define dblfix_bunfastins_nocheck(b, p, h, t, hs, ts)    lngfix_bunfastins_nocheck(b, p, h, t, hs, ts)
#define dblfix_bunfastins(b, h, t)                  lngfix_bunfastins(b, h, t)




#define vardbl_bunfastins_nocheck_noinc(b, p, h, t) varlng_bunfastins_nocheck_noinc(b, p, h, t)
#define vardbl_bunfastins_nocheck(b, p, h, t, hs, ts)    varlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define vardbl_bunfastins(b, h, t)                  varlng_bunfastins(b, h, t)
#define dblvar_bunfastins_nocheck_noinc(b, p, h, t) lngvar_bunfastins_nocheck_noinc(b, p, h, t)
#define dblvar_bunfastins_nocheck(b, p, h, t, hs, ts)    lngvar_bunfastins_nocheck(b, p, h, t, hs, ts)
#define dblvar_bunfastins(b, h, t)                  lngvar_bunfastins(b, h, t)




#if SIZEOF_OID == SIZEOF_INT

#define voidoid_bunfastins_nocheck_noinc(b, p, h, t) voidint_bunfastins_nocheck_noinc(b, p, h, t)
#define voidoid_bunfastins_nocheck(b, p, h, t, hs, ts)    voidint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define voidoid_bunfastins(b, h, t)                  voidint_bunfastins(b, h, t)
#define oidvoid_bunfastins_nocheck_noinc(b, p, h, t) intvoid_bunfastins_nocheck_noinc(b, p, h, t)
#define oidvoid_bunfastins_nocheck(b, p, h, t, hs, ts)    intvoid_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidvoid_bunfastins(b, h, t)                  intvoid_bunfastins(b, h, t)




#define chroid_bunfastins_nocheck_noinc(b, p, h, t) chrint_bunfastins_nocheck_noinc(b, p, h, t)
#define chroid_bunfastins_nocheck(b, p, h, t, hs, ts)    chrint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define chroid_bunfastins(b, h, t)                  chrint_bunfastins(b, h, t)
#define oidchr_bunfastins_nocheck_noinc(b, p, h, t) intchr_bunfastins_nocheck_noinc(b, p, h, t)
#define oidchr_bunfastins_nocheck(b, p, h, t, hs, ts)    intchr_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidchr_bunfastins(b, h, t)                  intchr_bunfastins(b, h, t)




#define bteoid_bunfastins_nocheck_noinc(b, p, h, t) bteint_bunfastins_nocheck_noinc(b, p, h, t)
#define bteoid_bunfastins_nocheck(b, p, h, t, hs, ts)    bteint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define bteoid_bunfastins(b, h, t)                  bteint_bunfastins(b, h, t)
#define oidbte_bunfastins_nocheck_noinc(b, p, h, t) intbte_bunfastins_nocheck_noinc(b, p, h, t)
#define oidbte_bunfastins_nocheck(b, p, h, t, hs, ts)    intbte_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidbte_bunfastins(b, h, t)                  intbte_bunfastins(b, h, t)




#define shtoid_bunfastins_nocheck_noinc(b, p, h, t) shtint_bunfastins_nocheck_noinc(b, p, h, t)
#define shtoid_bunfastins_nocheck(b, p, h, t, hs, ts)    shtint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define shtoid_bunfastins(b, h, t)                  shtint_bunfastins(b, h, t)
#define oidsht_bunfastins_nocheck_noinc(b, p, h, t) intsht_bunfastins_nocheck_noinc(b, p, h, t)
#define oidsht_bunfastins_nocheck(b, p, h, t, hs, ts)    intsht_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidsht_bunfastins(b, h, t)                  intsht_bunfastins(b, h, t)




#define intoid_bunfastins_nocheck_noinc(b, p, h, t) intint_bunfastins_nocheck_noinc(b, p, h, t)
#define intoid_bunfastins_nocheck(b, p, h, t, hs, ts)    intint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define intoid_bunfastins(b, h, t)                  intint_bunfastins(b, h, t)
#define oidint_bunfastins_nocheck_noinc(b, p, h, t) intint_bunfastins_nocheck_noinc(b, p, h, t)
#define oidint_bunfastins_nocheck(b, p, h, t, hs, ts)    intint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidint_bunfastins(b, h, t)                  intint_bunfastins(b, h, t)




#define wrdoid_bunfastins_nocheck_noinc(b, p, h, t) wrdint_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdoid_bunfastins_nocheck(b, p, h, t, hs, ts)    wrdint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdoid_bunfastins(b, h, t)                  wrdint_bunfastins(b, h, t)
#define oidwrd_bunfastins_nocheck_noinc(b, p, h, t) intwrd_bunfastins_nocheck_noinc(b, p, h, t)
#define oidwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    intwrd_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidwrd_bunfastins(b, h, t)                  intwrd_bunfastins(b, h, t)




#define lngoid_bunfastins_nocheck_noinc(b, p, h, t) lngint_bunfastins_nocheck_noinc(b, p, h, t)
#define lngoid_bunfastins_nocheck(b, p, h, t, hs, ts)    lngint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define lngoid_bunfastins(b, h, t)                  lngint_bunfastins(b, h, t)
#define oidlng_bunfastins_nocheck_noinc(b, p, h, t) intlng_bunfastins_nocheck_noinc(b, p, h, t)
#define oidlng_bunfastins_nocheck(b, p, h, t, hs, ts)    intlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidlng_bunfastins(b, h, t)                  intlng_bunfastins(b, h, t)




#define fltoid_bunfastins_nocheck_noinc(b, p, h, t) fltint_bunfastins_nocheck_noinc(b, p, h, t)
#define fltoid_bunfastins_nocheck(b, p, h, t, hs, ts)    fltint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fltoid_bunfastins(b, h, t)                  fltint_bunfastins(b, h, t)
#define oidflt_bunfastins_nocheck_noinc(b, p, h, t) intflt_bunfastins_nocheck_noinc(b, p, h, t)
#define oidflt_bunfastins_nocheck(b, p, h, t, hs, ts)    intflt_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidflt_bunfastins(b, h, t)                  intflt_bunfastins(b, h, t)




#define dbloid_bunfastins_nocheck_noinc(b, p, h, t) dblint_bunfastins_nocheck_noinc(b, p, h, t)
#define dbloid_bunfastins_nocheck(b, p, h, t, hs, ts)    dblint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define dbloid_bunfastins(b, h, t)                  dblint_bunfastins(b, h, t)
#define oiddbl_bunfastins_nocheck_noinc(b, p, h, t) intdbl_bunfastins_nocheck_noinc(b, p, h, t)
#define oiddbl_bunfastins_nocheck(b, p, h, t, hs, ts)    intdbl_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oiddbl_bunfastins(b, h, t)                  intdbl_bunfastins(b, h, t)




#define fixoid_bunfastins_nocheck_noinc(b, p, h, t) fixint_bunfastins_nocheck_noinc(b, p, h, t)
#define fixoid_bunfastins_nocheck(b, p, h, t, hs, ts)    fixint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fixoid_bunfastins(b, h, t)                  fixint_bunfastins(b, h, t)
#define oidfix_bunfastins_nocheck_noinc(b, p, h, t) intfix_bunfastins_nocheck_noinc(b, p, h, t)
#define oidfix_bunfastins_nocheck(b, p, h, t, hs, ts)    intfix_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidfix_bunfastins(b, h, t)                  intfix_bunfastins(b, h, t)




#define varoid_bunfastins_nocheck_noinc(b, p, h, t) varint_bunfastins_nocheck_noinc(b, p, h, t)
#define varoid_bunfastins_nocheck(b, p, h, t, hs, ts)    varint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define varoid_bunfastins(b, h, t)                  varint_bunfastins(b, h, t)
#define oidvar_bunfastins_nocheck_noinc(b, p, h, t) intvar_bunfastins_nocheck_noinc(b, p, h, t)
#define oidvar_bunfastins_nocheck(b, p, h, t, hs, ts)    intvar_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidvar_bunfastins(b, h, t)                  intvar_bunfastins(b, h, t)



#define oidoid_bunfastins_nocheck_noinc(b,p,h,t) intint_bunfastins_nocheck_noinc(b,p,h,t);
#else

#define voidoid_bunfastins_nocheck_noinc(b, p, h, t) voidlng_bunfastins_nocheck_noinc(b, p, h, t)
#define voidoid_bunfastins_nocheck(b, p, h, t, hs, ts)    voidlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define voidoid_bunfastins(b, h, t)                  voidlng_bunfastins(b, h, t)
#define oidvoid_bunfastins_nocheck_noinc(b, p, h, t) lngvoid_bunfastins_nocheck_noinc(b, p, h, t)
#define oidvoid_bunfastins_nocheck(b, p, h, t, hs, ts)    lngvoid_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidvoid_bunfastins(b, h, t)                  lngvoid_bunfastins(b, h, t)




#define chroid_bunfastins_nocheck_noinc(b, p, h, t) chrlng_bunfastins_nocheck_noinc(b, p, h, t)
#define chroid_bunfastins_nocheck(b, p, h, t, hs, ts)    chrlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define chroid_bunfastins(b, h, t)                  chrlng_bunfastins(b, h, t)
#define oidchr_bunfastins_nocheck_noinc(b, p, h, t) lngchr_bunfastins_nocheck_noinc(b, p, h, t)
#define oidchr_bunfastins_nocheck(b, p, h, t, hs, ts)    lngchr_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidchr_bunfastins(b, h, t)                  lngchr_bunfastins(b, h, t)




#define bteoid_bunfastins_nocheck_noinc(b, p, h, t) btelng_bunfastins_nocheck_noinc(b, p, h, t)
#define bteoid_bunfastins_nocheck(b, p, h, t, hs, ts)    btelng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define bteoid_bunfastins(b, h, t)                  btelng_bunfastins(b, h, t)
#define oidbte_bunfastins_nocheck_noinc(b, p, h, t) lngbte_bunfastins_nocheck_noinc(b, p, h, t)
#define oidbte_bunfastins_nocheck(b, p, h, t, hs, ts)    lngbte_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidbte_bunfastins(b, h, t)                  lngbte_bunfastins(b, h, t)




#define shtoid_bunfastins_nocheck_noinc(b, p, h, t) shtlng_bunfastins_nocheck_noinc(b, p, h, t)
#define shtoid_bunfastins_nocheck(b, p, h, t, hs, ts)    shtlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define shtoid_bunfastins(b, h, t)                  shtlng_bunfastins(b, h, t)
#define oidsht_bunfastins_nocheck_noinc(b, p, h, t) lngsht_bunfastins_nocheck_noinc(b, p, h, t)
#define oidsht_bunfastins_nocheck(b, p, h, t, hs, ts)    lngsht_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidsht_bunfastins(b, h, t)                  lngsht_bunfastins(b, h, t)




#define intoid_bunfastins_nocheck_noinc(b, p, h, t) intlng_bunfastins_nocheck_noinc(b, p, h, t)
#define intoid_bunfastins_nocheck(b, p, h, t, hs, ts)    intlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define intoid_bunfastins(b, h, t)                  intlng_bunfastins(b, h, t)
#define oidint_bunfastins_nocheck_noinc(b, p, h, t) lngint_bunfastins_nocheck_noinc(b, p, h, t)
#define oidint_bunfastins_nocheck(b, p, h, t, hs, ts)    lngint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidint_bunfastins(b, h, t)                  lngint_bunfastins(b, h, t)




#define wrdoid_bunfastins_nocheck_noinc(b, p, h, t) wrdlng_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdoid_bunfastins_nocheck(b, p, h, t, hs, ts)    wrdlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdoid_bunfastins(b, h, t)                  wrdlng_bunfastins(b, h, t)
#define oidwrd_bunfastins_nocheck_noinc(b, p, h, t) lngwrd_bunfastins_nocheck_noinc(b, p, h, t)
#define oidwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    lngwrd_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidwrd_bunfastins(b, h, t)                  lngwrd_bunfastins(b, h, t)




#define lngoid_bunfastins_nocheck_noinc(b, p, h, t) lnglng_bunfastins_nocheck_noinc(b, p, h, t)
#define lngoid_bunfastins_nocheck(b, p, h, t, hs, ts)    lnglng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define lngoid_bunfastins(b, h, t)                  lnglng_bunfastins(b, h, t)
#define oidlng_bunfastins_nocheck_noinc(b, p, h, t) lnglng_bunfastins_nocheck_noinc(b, p, h, t)
#define oidlng_bunfastins_nocheck(b, p, h, t, hs, ts)    lnglng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidlng_bunfastins(b, h, t)                  lnglng_bunfastins(b, h, t)




#define fltoid_bunfastins_nocheck_noinc(b, p, h, t) fltlng_bunfastins_nocheck_noinc(b, p, h, t)
#define fltoid_bunfastins_nocheck(b, p, h, t, hs, ts)    fltlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fltoid_bunfastins(b, h, t)                  fltlng_bunfastins(b, h, t)
#define oidflt_bunfastins_nocheck_noinc(b, p, h, t) lngflt_bunfastins_nocheck_noinc(b, p, h, t)
#define oidflt_bunfastins_nocheck(b, p, h, t, hs, ts)    lngflt_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidflt_bunfastins(b, h, t)                  lngflt_bunfastins(b, h, t)




#define dbloid_bunfastins_nocheck_noinc(b, p, h, t) dbllng_bunfastins_nocheck_noinc(b, p, h, t)
#define dbloid_bunfastins_nocheck(b, p, h, t, hs, ts)    dbllng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define dbloid_bunfastins(b, h, t)                  dbllng_bunfastins(b, h, t)
#define oiddbl_bunfastins_nocheck_noinc(b, p, h, t) lngdbl_bunfastins_nocheck_noinc(b, p, h, t)
#define oiddbl_bunfastins_nocheck(b, p, h, t, hs, ts)    lngdbl_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oiddbl_bunfastins(b, h, t)                  lngdbl_bunfastins(b, h, t)




#define fixoid_bunfastins_nocheck_noinc(b, p, h, t) fixlng_bunfastins_nocheck_noinc(b, p, h, t)
#define fixoid_bunfastins_nocheck(b, p, h, t, hs, ts)    fixlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fixoid_bunfastins(b, h, t)                  fixlng_bunfastins(b, h, t)
#define oidfix_bunfastins_nocheck_noinc(b, p, h, t) lngfix_bunfastins_nocheck_noinc(b, p, h, t)
#define oidfix_bunfastins_nocheck(b, p, h, t, hs, ts)    lngfix_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidfix_bunfastins(b, h, t)                  lngfix_bunfastins(b, h, t)




#define varoid_bunfastins_nocheck_noinc(b, p, h, t) varlng_bunfastins_nocheck_noinc(b, p, h, t)
#define varoid_bunfastins_nocheck(b, p, h, t, hs, ts)    varlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define varoid_bunfastins(b, h, t)                  varlng_bunfastins(b, h, t)
#define oidvar_bunfastins_nocheck_noinc(b, p, h, t) lngvar_bunfastins_nocheck_noinc(b, p, h, t)
#define oidvar_bunfastins_nocheck(b, p, h, t, hs, ts)    lngvar_bunfastins_nocheck(b, p, h, t, hs, ts)
#define oidvar_bunfastins(b, h, t)                  lngvar_bunfastins(b, h, t)



#define oidoid_bunfastins_nocheck_noinc(b,p,h,t) lnglng_bunfastins_nocheck_noinc(b,p,h,t);
#endif /* SIZEOF_OID == SIZEOF_INT */

#if SIZEOF_WRD == SIZEOF_INT

#define voidwrd_bunfastins_nocheck_noinc(b, p, h, t) voidint_bunfastins_nocheck_noinc(b, p, h, t)
#define voidwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    voidint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define voidwrd_bunfastins(b, h, t)                  voidint_bunfastins(b, h, t)
#define wrdvoid_bunfastins_nocheck_noinc(b, p, h, t) intvoid_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdvoid_bunfastins_nocheck(b, p, h, t, hs, ts)    intvoid_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdvoid_bunfastins(b, h, t)                  intvoid_bunfastins(b, h, t)




#define chrwrd_bunfastins_nocheck_noinc(b, p, h, t) chrint_bunfastins_nocheck_noinc(b, p, h, t)
#define chrwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    chrint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define chrwrd_bunfastins(b, h, t)                  chrint_bunfastins(b, h, t)
#define wrdchr_bunfastins_nocheck_noinc(b, p, h, t) intchr_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdchr_bunfastins_nocheck(b, p, h, t, hs, ts)    intchr_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdchr_bunfastins(b, h, t)                  intchr_bunfastins(b, h, t)



/*
#define btewrd_bunfastins_nocheck_noinc(b, p, h, t) bteint_bunfastins_nocheck_noinc(b, p, h, t)
#define btewrd_bunfastins_nocheck(b, p, h, t, hs, ts)    bteint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define btewrd_bunfastins(b, h, t)                  bteint_bunfastins(b, h, t)
#define wrdbte_bunfastins_nocheck_noinc(b, p, h, t) intbte_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdbte_bunfastins_nocheck(b, p, h, t, hs, ts)    intbte_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdbte_bunfastins(b, h, t)                  intbte_bunfastins(b, h, t)


*/

#define shtwrd_bunfastins_nocheck_noinc(b, p, h, t) shtint_bunfastins_nocheck_noinc(b, p, h, t)
#define shtwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    shtint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define shtwrd_bunfastins(b, h, t)                  shtint_bunfastins(b, h, t)
#define wrdsht_bunfastins_nocheck_noinc(b, p, h, t) intsht_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdsht_bunfastins_nocheck(b, p, h, t, hs, ts)    intsht_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdsht_bunfastins(b, h, t)                  intsht_bunfastins(b, h, t)




#define intwrd_bunfastins_nocheck_noinc(b, p, h, t) intint_bunfastins_nocheck_noinc(b, p, h, t)
#define intwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    intint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define intwrd_bunfastins(b, h, t)                  intint_bunfastins(b, h, t)
#define wrdint_bunfastins_nocheck_noinc(b, p, h, t) intint_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdint_bunfastins_nocheck(b, p, h, t, hs, ts)    intint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdint_bunfastins(b, h, t)                  intint_bunfastins(b, h, t)




#define lngwrd_bunfastins_nocheck_noinc(b, p, h, t) lngint_bunfastins_nocheck_noinc(b, p, h, t)
#define lngwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    lngint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define lngwrd_bunfastins(b, h, t)                  lngint_bunfastins(b, h, t)
#define wrdlng_bunfastins_nocheck_noinc(b, p, h, t) intlng_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdlng_bunfastins_nocheck(b, p, h, t, hs, ts)    intlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdlng_bunfastins(b, h, t)                  intlng_bunfastins(b, h, t)



/*
#define fltwrd_bunfastins_nocheck_noinc(b, p, h, t) fltint_bunfastins_nocheck_noinc(b, p, h, t)
#define fltwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    fltint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fltwrd_bunfastins(b, h, t)                  fltint_bunfastins(b, h, t)
#define wrdflt_bunfastins_nocheck_noinc(b, p, h, t) intflt_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdflt_bunfastins_nocheck(b, p, h, t, hs, ts)    intflt_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdflt_bunfastins(b, h, t)                  intflt_bunfastins(b, h, t)


*/
/*
#define dblwrd_bunfastins_nocheck_noinc(b, p, h, t) dblint_bunfastins_nocheck_noinc(b, p, h, t)
#define dblwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    dblint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define dblwrd_bunfastins(b, h, t)                  dblint_bunfastins(b, h, t)
#define wrddbl_bunfastins_nocheck_noinc(b, p, h, t) intdbl_bunfastins_nocheck_noinc(b, p, h, t)
#define wrddbl_bunfastins_nocheck(b, p, h, t, hs, ts)    intdbl_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrddbl_bunfastins(b, h, t)                  intdbl_bunfastins(b, h, t)


*/

#define fixwrd_bunfastins_nocheck_noinc(b, p, h, t) fixint_bunfastins_nocheck_noinc(b, p, h, t)
#define fixwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    fixint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fixwrd_bunfastins(b, h, t)                  fixint_bunfastins(b, h, t)
#define wrdfix_bunfastins_nocheck_noinc(b, p, h, t) intfix_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdfix_bunfastins_nocheck(b, p, h, t, hs, ts)    intfix_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdfix_bunfastins(b, h, t)                  intfix_bunfastins(b, h, t)




#define varwrd_bunfastins_nocheck_noinc(b, p, h, t) varint_bunfastins_nocheck_noinc(b, p, h, t)
#define varwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    varint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define varwrd_bunfastins(b, h, t)                  varint_bunfastins(b, h, t)
#define wrdvar_bunfastins_nocheck_noinc(b, p, h, t) intvar_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdvar_bunfastins_nocheck(b, p, h, t, hs, ts)    intvar_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdvar_bunfastins(b, h, t)                  intvar_bunfastins(b, h, t)



#else

#define voidwrd_bunfastins_nocheck_noinc(b, p, h, t) voidlng_bunfastins_nocheck_noinc(b, p, h, t)
#define voidwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    voidlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define voidwrd_bunfastins(b, h, t)                  voidlng_bunfastins(b, h, t)
#define wrdvoid_bunfastins_nocheck_noinc(b, p, h, t) lngvoid_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdvoid_bunfastins_nocheck(b, p, h, t, hs, ts)    lngvoid_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdvoid_bunfastins(b, h, t)                  lngvoid_bunfastins(b, h, t)




#define chrwrd_bunfastins_nocheck_noinc(b, p, h, t) chrlng_bunfastins_nocheck_noinc(b, p, h, t)
#define chrwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    chrlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define chrwrd_bunfastins(b, h, t)                  chrlng_bunfastins(b, h, t)
#define wrdchr_bunfastins_nocheck_noinc(b, p, h, t) lngchr_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdchr_bunfastins_nocheck(b, p, h, t, hs, ts)    lngchr_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdchr_bunfastins(b, h, t)                  lngchr_bunfastins(b, h, t)



/*
#define btewrd_bunfastins_nocheck_noinc(b, p, h, t) btelng_bunfastins_nocheck_noinc(b, p, h, t)
#define btewrd_bunfastins_nocheck(b, p, h, t, hs, ts)    btelng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define btewrd_bunfastins(b, h, t)                  btelng_bunfastins(b, h, t)
#define wrdbte_bunfastins_nocheck_noinc(b, p, h, t) lngbte_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdbte_bunfastins_nocheck(b, p, h, t, hs, ts)    lngbte_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdbte_bunfastins(b, h, t)                  lngbte_bunfastins(b, h, t)


*/

#define shtwrd_bunfastins_nocheck_noinc(b, p, h, t) shtlng_bunfastins_nocheck_noinc(b, p, h, t)
#define shtwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    shtlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define shtwrd_bunfastins(b, h, t)                  shtlng_bunfastins(b, h, t)
#define wrdsht_bunfastins_nocheck_noinc(b, p, h, t) lngsht_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdsht_bunfastins_nocheck(b, p, h, t, hs, ts)    lngsht_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdsht_bunfastins(b, h, t)                  lngsht_bunfastins(b, h, t)




#define intwrd_bunfastins_nocheck_noinc(b, p, h, t) intlng_bunfastins_nocheck_noinc(b, p, h, t)
#define intwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    intlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define intwrd_bunfastins(b, h, t)                  intlng_bunfastins(b, h, t)
#define wrdint_bunfastins_nocheck_noinc(b, p, h, t) lngint_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdint_bunfastins_nocheck(b, p, h, t, hs, ts)    lngint_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdint_bunfastins(b, h, t)                  lngint_bunfastins(b, h, t)




#define lngwrd_bunfastins_nocheck_noinc(b, p, h, t) lnglng_bunfastins_nocheck_noinc(b, p, h, t)
#define lngwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    lnglng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define lngwrd_bunfastins(b, h, t)                  lnglng_bunfastins(b, h, t)
#define wrdlng_bunfastins_nocheck_noinc(b, p, h, t) lnglng_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdlng_bunfastins_nocheck(b, p, h, t, hs, ts)    lnglng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdlng_bunfastins(b, h, t)                  lnglng_bunfastins(b, h, t)



/*
#define fltwrd_bunfastins_nocheck_noinc(b, p, h, t) fltlng_bunfastins_nocheck_noinc(b, p, h, t)
#define fltwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    fltlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fltwrd_bunfastins(b, h, t)                  fltlng_bunfastins(b, h, t)
#define wrdflt_bunfastins_nocheck_noinc(b, p, h, t) lngflt_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdflt_bunfastins_nocheck(b, p, h, t, hs, ts)    lngflt_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdflt_bunfastins(b, h, t)                  lngflt_bunfastins(b, h, t)


*/
/*
#define dblwrd_bunfastins_nocheck_noinc(b, p, h, t) dbllng_bunfastins_nocheck_noinc(b, p, h, t)
#define dblwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    dbllng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define dblwrd_bunfastins(b, h, t)                  dbllng_bunfastins(b, h, t)
#define wrddbl_bunfastins_nocheck_noinc(b, p, h, t) lngdbl_bunfastins_nocheck_noinc(b, p, h, t)
#define wrddbl_bunfastins_nocheck(b, p, h, t, hs, ts)    lngdbl_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrddbl_bunfastins(b, h, t)                  lngdbl_bunfastins(b, h, t)


*/

#define fixwrd_bunfastins_nocheck_noinc(b, p, h, t) fixlng_bunfastins_nocheck_noinc(b, p, h, t)
#define fixwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    fixlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define fixwrd_bunfastins(b, h, t)                  fixlng_bunfastins(b, h, t)
#define wrdfix_bunfastins_nocheck_noinc(b, p, h, t) lngfix_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdfix_bunfastins_nocheck(b, p, h, t, hs, ts)    lngfix_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdfix_bunfastins(b, h, t)                  lngfix_bunfastins(b, h, t)




#define varwrd_bunfastins_nocheck_noinc(b, p, h, t) varlng_bunfastins_nocheck_noinc(b, p, h, t)
#define varwrd_bunfastins_nocheck(b, p, h, t, hs, ts)    varlng_bunfastins_nocheck(b, p, h, t, hs, ts)
#define varwrd_bunfastins(b, h, t)                  varlng_bunfastins(b, h, t)
#define wrdvar_bunfastins_nocheck_noinc(b, p, h, t) lngvar_bunfastins_nocheck_noinc(b, p, h, t)
#define wrdvar_bunfastins_nocheck(b, p, h, t, hs, ts)    lngvar_bunfastins_nocheck(b, p, h, t, hs, ts)
#define wrdvar_bunfastins(b, h, t)                  lngvar_bunfastins(b, h, t)



#endif /* SIZEOF_WRD == SIZEOF_INT */



BAT *BAT_scanselect(BAT *b, BAT *bn, ptr tl, ptr th, bit li, bit hi, int equi, int lval, int hval, int nocheck);

#endif /* _GDK_SCANSELECT_H */


