/*
 * The contents of this file are subject to the MonetDB Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://monetdb.cwi.nl/Legal/MonetDBLicense-1.1.html
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is the MonetDB Database System.
 *
 * The Initial Developer of the Original Code is CWI.
 * Portions created by CWI are Copyright (C) 1997-2008 CWI.
 * All Rights Reserved.
 */

#if (!defined __GNUC__) && defined __INTEL_COMPILER && __INTEL_COMPILER >= 800
/*
 * With "-no-gcc", icc 8.0 does not predefine __GNUC__, and hence __REDIRECT
 * is not defined in /usr/include/sys/cdefs.h; which in turn causes readdir to
 * be defined as readdir64 in /usr/include/dirent.h .
 * To prevent the latter, we ensure here that __REDIRECT is defined also for 
 * icc 8.0 with "-no-gcc".
 */
# define __REDIRECT(name, proto, alias) name proto __asm__ (__ASMNAME (#alias))
# ifdef __cplusplus
#  define __REDIRECT_NTH(name, proto, alias) \
     name proto __THROW __asm__ (__ASMNAME (#alias))
# else
#  define __REDIRECT_NTH(name, proto, alias) \
     name proto __asm__ (__ASMNAME (#alias)) __THROW
# endif
# define __ASMNAME(cname)  __ASMNAME2 (__USER_LABEL_PREFIX__, cname)
# define __ASMNAME2(prefix, cname) __STRING (prefix) cname
# define __interface
/* work around bug in glibc header files */
#ifndef __GLIBC_HAVE_LONG_LONG
#define __GLIBC_HAVE_LONG_LONG 1
#endif
#endif
